
import sys
import operator
import numpy as np
from sklearn.metrics.pairwise import cosine_similarity
from sklearn.metrics.pairwise import paired_euclidean_distances

dictionary = []

sentences_log_topic = [] #sentence log_topic

query_log_topic = [] #sentence log_topic

category ={}

def loadSentencesembeddings(sentences_probability):
    vectorslines = open(sentences_probability,"r", encoding = "utf-8")
    for line in vectorslines:
        linelist = line.lstrip().rstrip().split("##")
        temp_list =[]
        tempv = np.asarray(linelist[1].lstrip().rstrip().split(), dtype=np.float32)
        tempc = linelist[0].lstrip().rstrip()
        tempd = 0.0
        temp_list.append(tempv)
        temp_list.append(tempc)
        temp_list.append(tempd)
        sentences_log_topic.append(temp_list)

def loadQueryembeddings(sentences_probability):
    vectorslines = open(sentences_probability,"r", encoding = "utf-8")
    for line in vectorslines:
        linelist = line.lstrip().rstrip().split("##")
        temp_list =[]
        tempv = np.asarray(eval(linelist[2].lstrip().rstrip()), dtype=np.float32)
        tempc = linelist[0].lstrip().rstrip()
        temp_list.append(tempv)
        temp_list.append(tempc)
        query_log_topic.append(temp_list)

def countCategory():
    for line in sentences_log_topic:
        if line[1] not in category:
            category.setdefault(line[1].lstrip().rstrip(), 1)
        else:
            category[line[1].lstrip().rstrip()] += 1

def computeCosine(targetvalue, t_c,topn):
    for item in sentences_log_topic:
        v_c = 1- cosine_similarity([targetvalue], [item[0]])
        item[2] = v_c[0][0]
    sentences_log_topic.sort(key=lambda ele:ele[2], reverse=False)
    
    flagt = 0
    for i in range(topn):
        if sentences_log_topic[i][1] == t_c:
            flagt += 1
    
    recall = flagt / category[t_c]
    precision = flagt / topn
    if recall + precision == 0.0:
        f1 = 0.0
    else:
        f1 = 2 * recall*precision /(precision + recall)
    
    return recall, precision, f1

def printRPF(topn):
    recall_all = 0
    precision_all =0
    f1_all =0
    
    for item in query_log_topic:
        recall, precision, f1 = computeCosine(item[0],item[1],topn)
        recall_all += recall
        precision_all += precision
        f1_all += f1
        #print("precision: " + str(precision) +" recall: " + str(recall) + " f1: "+str(f1))
    
    f1_all = f1_all / len(query_log_topic)
    precision_all = precision_all / len(query_log_topic)
    recall_all = recall_all / len(query_log_topic)
    
    print("precision: " + str(precision_all) +" recall: " + str(recall_all) + " f1: "+str(f1_all))
    print("  ")
    pass

if __name__ == '__main__':
    
    database_file = "./searchengine.txt"
    Query_file = "./querylist.txt"
    
    print("Begin to load sentences probabilities.")
    #loadSentencesembeddings(database_file)
    #loadQueryembeddings(Query_file)
    countCategory()
    
    topn_list = [20, 30, 40, 50, 60, 70, 80, 90, 100, 300, 600, 1000]
    for tpn in topn_list:
        print("@" + str(tpn))
        printRPF(tpn)
        
    print("end")
    pass