
from numpy import *
import numpy as np
import operator
import random
import copy
import sys
import re
import time
import os
from multiprocessing import Process, Manager
from copy import deepcopy
from collections import Counter

from sklearn.metrics import precision_score, recall_score, f1_score,accuracy_score
from sklearn.model_selection import cross_validate

from sklearn import metrics

from sklearn.model_selection import KFold
from sklearn.model_selection import train_test_split
from sklearn import datasets
from sklearn.svm import SVC
from sklearn.datasets import load_svmlight_file


def convertToSVMinput(inputsourceVectors, inputsourceLabels,svmfile):
    vectors = []
    classlabel = []
    classlabeltypes = []
    vectorDimension = 0
    for line in inputsourceVectors:
        #vector = line.strip().rstrip().lstrip().split(" ")
        vectorDimension = len(line)
        vectors.append(line)
    #inputsourceLabels.seek(0)
    for lab in inputsourceLabels:
        lab = lab.strip().rstrip().lstrip()
        if lab not in classlabeltypes:
            classlabeltypes.append(lab)
    #inputsourceLabels.seek(0)
    for linel in inputsourceLabels:
        label = linel.strip().rstrip().lstrip()
        classlabel.append(classlabeltypes.index(label))

    for i in range(len(vectors)):
        svmfile.write(str(classlabel[i]) + " ")
        temp = vectors[i]
        for j in range(vectorDimension):
            svmfile.write(str(j))
            svmfile.write(":")
            svmfile.write(str(temp[j]))
            svmfile.write(" ")
        svmfile.write('\n')
    svmfile.flush()
    svmfile.close()

def svmClassifer5Fold(svmfile):
    Data_train, label_train = load_svmlight_file(svmfile)
    
    np.random.seed(10)
    shuffle_indices = np.random.permutation(np.arange(Data_train.shape[0]))
    
    x_shuffled = Data_train[shuffle_indices]
    y_shuffled = label_train[shuffle_indices]
    
    #vectorNumber = x_shuffled.shape[0]
        
    #kf = cross_validation.KFold(vectorNumber, n_folds=5, shuffle=True, random_state=3)
    kf = KFold(n_splits=5)
    
    scoreNum = []
    f1Num = []
    for train_index, test_index in kf.split(x_shuffled):
        X_train, X_test = x_shuffled[train_index], x_shuffled[test_index]
        y_train, y_test = y_shuffled[train_index], y_shuffled[test_index]

        f1value, score = computeAcc(X_train, y_train,X_test, y_test)
        
        scoreNum.append(score)
        f1Num.append(f1value)
    return scoreNum,f1Num
    
def computeAcc(X_train, y_train,X_test, y_test):
    clf = SVC(C=2.0, cache_size=200, class_weight=None, coef0=0.0, degree=5, kernel='rbf', max_iter=-1, probability=True,
    random_state=None, shrinking=True, tol=0.1, verbose=False,gamma='auto')
    clf.fit(X_train, y_train)
    y_pred = clf.predict(X_test)
    
    f1value = f1_score(y_test, y_pred,average="weighted")
    acc = accuracy_score(y_test, y_pred)
    print(f1value)
    print(acc)
    return f1value, acc

def crossvalidationfunction(oDir, num,):
    print("\n start classify: "+str(num))
    start1 = time.time()
    
    senvector_svmfile = open(oDir +"senvectorsvmFormatVectors_"+str(num), "rb")
    senvectorscoreNum,f1Num = svmClassifer5Fold(senvector_svmfile)
    print("The accuracy of sentence vectors is : "+str(num))
    print(str(np.sum(senvectorscoreNum) / 5.0) + " acc  std : " + str(np.std(senvectorscoreNum)))
    print(str(num)+"------------")
    print("The f1 of sentence vectors is : "+str(num))
    print(str(np.sum(f1Num) / 5.0) + " std: " + str(np.std(f1Num)))
    print(str(num)+"*****************")
    
    end1 = time.time()
    print("end classify "+str(num)+", and the time is " + str(end1-start1)+"\n\n")

if __name__ == '__main__':
    
    if (len(sys.argv) != 3):
        print(" python build <dropoutfile>  <model_root>")
        print(" ")
        exit(0)
    
    openfile = open(sys.argv[1], "r", encoding = "utf-8")
    model_root = sys.argv[2]
    ##
    select_out_category = {}
    for line in openfile:
        ca = line.strip().split("##")[0]
        if ca not in select_out_category:
            select_out_category.setdefault(ca, 1)
        else:
            select_out_category[ca] +=1
    log_sorted = sorted(select_out_category.items(), key=operator.itemgetter(1),  reverse=True)[:40]
    
    select_category = []
    for item in log_sorted:
        select_category.append(item[0])
    print(select_category)
    
    all_senvector1 = [];
    Labels = []
    openfile.seek(0)
    
    for line in openfile:
        linelist = line.lstrip().rstrip().split("##")
        label = linelist[0]
        if label in select_category:
            Labels.append(linelist[0])
            all_senvector1.append(linelist[1].lstrip().rstrip().split())
    
    print(len(all_senvector1))
    print("convert vectors to svm format...")
    
    senvector1svmfile = open(model_root +"senvectorsvmFormatVectors_1", "w", encoding = "utf-8")
    convertToSVMinput(all_senvector1, Labels, senvector1svmfile)
    
    print("begin to multiProcesses classify...\n")
    
    crossvalidationfunction(model_root,1,)
    
    
        
        