
import sys
from scipy import spatial
import operator
import numpy as np
import random

dictionary = []

words_phi = {} # phi

def loadWordembeddings(phifile):
    philines = open(phifile,"r", encoding = "utf-8")
    tagno =0
    for topics_string in philines:
        tagprobabilitylist = topics_string.split()
        word = dictionary[tagno]
        if word not in words_phi:
            words_phi.setdefault(word)
            words_phi[word] = tagprobabilitylist
        tagno = tagno+1


def getDictionary(vocab_file):
    vocab = open(vocab_file, 'r', encoding = "utf-8").readlines()
    for line in vocab:
        dictionary.append(line.strip().rstrip().split(":")[1])
    pass

inputfile_orginaltext = open("./originalForsearch.txt","r")

inputfile_text_vector = open("./tm/output/150.topic_dis","r")
inputfile_category = open("./cagegory.txt","r")

dictionary_file = "./dictionary.txt"
keyword_probability_file_phi = "./tm/output/150.theta"

outputfile = open("./querylist.txt","w")

list_inputfile_orginaltext = []
list_inputfile_text_vector = []
list_inputfile_category=[]

for line in inputfile_orginaltext:
    list_inputfile_orginaltext.append(line.rstrip().lstrip())

for line in inputfile_text_vector:
    list_inputfile_text_vector.append(line.rstrip().lstrip())

for line in inputfile_category:
    list_inputfile_category.append(line.rstrip().lstrip())

len_l = len(list_inputfile_category)

# read
print("Begin to read dictionary.")
getDictionary(dictionary_file)

print("Begin to load word probabilities.")
loadWordembeddings(keyword_probability_file_phi)

inputfile_category.seek(0)

##select out the top 20 category
category = {}
for line in inputfile_category:
    ca = line.strip()
    if ca not in category:
        category.setdefault(ca, 1)
    else:
        category[ca] += 1
log_sorted = sorted(category.items(), key=operator.itemgetter(1),  reverse=True)[:25]
select_category = []
for item in log_sorted:
    select_category.append(item[0])

querylist_word = {}
querylist_sentence = {}
querylist_phrase = {}

for id in range(len_l):
    print(id)
    item = list_inputfile_orginaltext[id].strip()
    keyword_list = item.split(".")[-1].split(" ")
    category = list_inputfile_category[id]
    sentence_vector = list_inputfile_text_vector[id].strip().split()
    if category not in select_category:
        continue
    for k in keyword_list:
        if k.strip() in dictionary:
            temp = (category,list(map(eval, words_phi[k.strip()])))
            #temp.append(category,words_phi[k])
            querylist_word.setdefault(k.strip(), temp)
            break
        
    temp2 = (category, list(map(eval, sentence_vector)))
    querylist_sentence.setdefault(item,temp2)
    
    phrase = ""
    phrase_vector=[0.0 for i in range(100)]
    key_num =0
    for k in keyword_list:
        if k.strip() in dictionary:
            key_num+=1
            phrase = phrase + " " + k.strip()
            k_value = list(map(eval, words_phi[k]))
            phrase_vector = [a + b for a,b in zip(phrase_vector, k_value)]
            #phrase_vector = phrase_vector.add(list(map(eval, words_phi[k])))
    
    if key_num == 0:
        continue
    phrase_vector = [ m/key_num for m in phrase_vector]
    temp3 = (category,phrase_vector)
    querylist_phrase.setdefault(phrase,temp3)
    
print(len(querylist_phrase))
print(len(querylist_word))
print(len(querylist_sentence))

querylist_w = []
querylist_s = []
querylist_p = []

for k,v in querylist_word.items():
    querylist_w.append(v[0] + "##" + k+"##" +str(v[1]))

for k,v in querylist_sentence.items():
    querylist_s.append(v[0] + "##" + k+"##" +str(v[1]))

for k,v in querylist_phrase.items():
    querylist_p.append(v[0] + "##" + k+"##" +str(v[1]))
    
print(len(querylist_w))
print(len(querylist_s))
print(len(querylist_p))

random.shuffle(querylist_w)
random.shuffle(querylist_s)
random.shuffle(querylist_p)

for w_n in range(100):
    outputfile.write(querylist_w[w_n] + "\n")

for s_n in range(700):
    outputfile.write(querylist_s[s_n] + "\n")

for p_n in range(200):
    outputfile.write(querylist_p[p_n] + "\n")

outputfile.close()
    
    