
import sys
from scipy import spatial
import operator
import numpy as np

dictionary = []

words_phi = {} # phi

sentences_log_topic = {} #sentence log_topic

def most_similar_sentences(list_tagname, topn):
    
    phrase_vector = np.empty(100,dtype=np.float32)
    for item in list_tagname:
        temp = np.asarray(words_phi[item], dtype=np.float32)
        phrase_vector += temp
    
    distancevec1 = {}
    #result = [1 - spatial.distance.cosine(tagvec, tagsDis[tag]) for tag in dictionary]
    for sen in sentences_log_topic:
        try:
            sentences_log_topic_t = np.asarray(sentences_log_topic[sen],dtype=np.float32).shape
      
            m = spatial.distance.cosine(phrase_vector, sentences_log_topic_t)
            print(m)
            distancevec1[sen] = 1 - spatial.distance.cosine(phrase_vector, sentences_log_topic_t)
        except TypeError:
            distancevec1[sen] = 0
            
    log_sorted = sorted(distancevec1.items(), key=operator.itemgetter(1),  reverse=True)[:topn]
    
    return log_sorted

def loadSentencesembeddings(sentences_probability):
    vectorslines = open(sentences_probability,"r", encoding = "utf-8")
    for line in vectorslines:
        linelist = line.lstrip().rstrip().split("##")
        sentences_log_topic.setdefault(linelist[2].lstrip().rstrip(),linelist[1].lstrip().rstrip().split())

def loadWordembeddings(phifile):
    philines = open(phifile,"r", encoding = "utf-8")
    tagno =0
    for topics_string in philines:
        tagprobabilitylist = topics_string.split()
        word = dictionary[tagno]
        if word not in words_phi:
            words_phi.setdefault(word)
            words_phi[word] = tagprobabilitylist
        tagno = tagno+1


def getDictionary(vocab_file):
    vocab = open(vocab_file, 'r', encoding = "utf-8").readlines()
    for line in vocab:
        dictionary.append(line.strip().rstrip().split(":")[1])
    pass

if __name__ == '__main__':
    
    if (len(sys.argv) != 4):
        print("usage: python showWordsMultiSemantics.py <dictionary file> <keyword_probability_file phi>  <sentences probalility over semantics file> \n")
        #print("<semanic probability over dictionary file(final.beta)>  <word probalility over semantics file(final.theta)> \n")
        sys.exit(1)
    
    dictionary_file = sys.argv[1]
    keyword_probability_file_phi = sys.argv[2]
    sentences_probability_file_phi = sys.argv[3]
    
    # read
    print("Begin to read dictionary.")
    getDictionary(dictionary_file)
    
    print("Begin to load word probabilities.")
    loadWordembeddings(keyword_probability_file_phi)
    
    print("Begin to load sentences probabilities.")
    loadSentencesembeddings(sentences_probability_file_phi)
    
    while True:
        tagname = str(input("Please input one phrase: "))
        if tagname is "":
            print("exit")
            exit(0)
        list_words = tagname.split(" ")

        if len(list_words) != 0:
            new_list_words = []
            for item in list_words:
                if item in words_phi.keys():
                    new_list_words.append(item)
                    
            topn = int(input("How many tops you want to print?"))
            
            log_sorted = most_similar_sentences(new_list_words,topn)
            
            print("log_topics results: ")
            print(log_sorted)
        else:
            print(" Please input some words.")
            continue
        
